Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -1119,88 +1167,198 @@
         goto end;
     } else
         *changed = TRUE;
-    
+
     Status = write_metadata_items(Vcb, &items, NULL, c, &rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("write_metadata_items returned %08x\n", Status);
         goto end;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
     Vcb->need_write = TRUE;
-    
+
 end:
+    if (NT_SUCCESS(Status)) {
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
+    }
+
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
-    
+
+    free_trees(Vcb);
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     while (!IsListEmpty(&items)) {
         metadata_reloc* mr = CONTAINING_RECORD(RemoveHeadList(&items), metadata_reloc, list_entry);
-        
+
         while (!IsListEmpty(&mr->refs)) {
             metadata_reloc_ref* ref = CONTAINING_RECORD(RemoveHeadList(&mr->refs), metadata_reloc_ref, list_entry);
-            
+
             ExFreePool(ref);
         }
-        
+
         ExFreePool(mr);
     }
-    
+
     return Status;
 }
 
-static NTSTATUS add_data_reloc(device_extension* Vcb, LIST_ENTRY* items, LIST_ENTRY* metadata_items, traverse_ptr* tp, chunk* c, LIST_ENTRY* rollback) {
+static NTSTATUS data_reloc_add_tree_edr(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* metadata_items,
+                                        data_reloc* dr, EXTENT_DATA_REF* edr, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    KEY searchkey;
+    traverse_ptr tp;
+    root* r = NULL;
+    metadata_reloc* mr;
+    UINT64 last_tree = 0;
+    data_reloc_ref* ref;
+
+    le = Vcb->roots.Flink;
+    while (le != &Vcb->roots) {
+        root* r2 = CONTAINING_RECORD(le, root, list_entry);
+
+        if (r2->id == edr->root) {
+            r = r2;
+            break;
+        }
+
+        le = le->Flink;
+    }
+
+    if (!r) {
+        ERR("could not find subvol %llx\n", edr->count);
+        return STATUS_INTERNAL_ERROR;
+    }
+
+    searchkey.obj_id = edr->objid;
+    searchkey.obj_type = TYPE_EXTENT_DATA;
+    searchkey.offset = 0;
+
+    Status = find_item(Vcb, r, &tp, &searchkey, FALSE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return Status;
+    }
+
+    if (tp.item->key.obj_id < searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type < searchkey.obj_type)) {
+        traverse_ptr tp2;
+
+        if (find_next_item(Vcb, &tp, &tp2, FALSE, NULL))
+            tp = tp2;
+        else {
+            ERR("could not find EXTENT_DATA for inode %llx in root %llx\n", searchkey.obj_id, r->id);
+            return STATUS_INTERNAL_ERROR;
+        }
+    }
+
+    ref = NULL;
+
+    while (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type) {
+        traverse_ptr tp2;
+
+        if (tp.item->size >= sizeof(EXTENT_DATA)) {
+            EXTENT_DATA* ed = (EXTENT_DATA*)tp.item->data;
+
+            if ((ed->type == EXTENT_TYPE_PREALLOC || ed->type == EXTENT_TYPE_REGULAR) && tp.item->size >= offsetof(EXTENT_DATA, data[0]) + sizeof(EXTENT_DATA2)) {
+                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
+
+                if (ed2->address == dr->address && ed2->size == dr->size && tp.item->key.offset - ed2->offset == edr->offset) {
+                    if (ref && last_tree == tp.tree->header.address)
+                        ref->edr.count++;
+                    else {
+                        ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
+                        if (!ref) {
+                            ERR("out of memory\n");
+                            return STATUS_INSUFFICIENT_RESOURCES;
+                        }
+
+                        ref->type = TYPE_EXTENT_DATA_REF;
+                        RtlCopyMemory(&ref->edr, edr, sizeof(EXTENT_DATA_REF));
+                        ref->edr.count = 1;
+
+                        Status = add_metadata_reloc_parent(Vcb, metadata_items, tp.tree->header.address, &mr, rollback);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("add_metadata_reloc_parent returned %08x\n", Status);
+                            ExFreePool(ref);
+                            return Status;
+                        }
+
+                        last_tree = tp.tree->header.address;
+                        ref->parent = mr;
+
+                        InsertTailList(&dr->refs, &ref->list_entry);
+                    }
+                }
+            }
+        }
+
+        if (find_next_item(Vcb, &tp, &tp2, FALSE, NULL))
+            tp = tp2;
+        else
+            break;
+    }
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS add_data_reloc(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* items, LIST_ENTRY* metadata_items,
+                               traverse_ptr* tp, chunk* c, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     data_reloc* dr;
     EXTENT_ITEM* ei;
     UINT16 len;
     UINT64 inline_rc;
     UINT8* ptr;
-    
+
     dr = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc), ALLOC_TAG);
     if (!dr) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     dr->address = tp->item->key.obj_id;
     dr->size = tp->item->key.offset;
     dr->ei = (EXTENT_ITEM*)tp->item->data;
     InitializeListHead(&dr->refs);
-    
-    delete_tree_item(Vcb, tp, rollback);
-    
+
+    Status = delete_tree_item(Vcb, tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     if (!c)
         c = get_chunk_from_address(Vcb, tp->item->key.obj_id);
-        
+
     if (c) {
         ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        decrease_chunk_usage(c, tp->item->key.offset);
-        
-        space_list_add(Vcb, c, TRUE, tp->item->key.obj_id, tp->item->key.offset, rollback);
-        
+
+        c->used -= tp->item->key.offset;
+
+        space_list_add(c, tp->item->key.obj_id, tp->item->key.offset, rollback);
+
         ExReleaseResourceLite(&c->lock);
     }
-    
+
     ei = (EXTENT_ITEM*)tp->item->data;
     inline_rc = 0;
-    
+
     len = tp->item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)tp->item->data + sizeof(EXTENT_ITEM);
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
-        ULONG sectlen = secttype == TYPE_EXTENT_DATA_REF ? sizeof(EXTENT_DATA_REF) : (secttype == TYPE_SHARED_DATA_REF ? sizeof(SHARED_DATA_REF) : 0);
-        data_reloc_ref* ref;
-        NTSTATUS Status;
-        metadata_reloc* mr;
-        
+        UINT16 sectlen = secttype == TYPE_EXTENT_DATA_REF ? sizeof(EXTENT_DATA_REF) : (secttype == TYPE_SHARED_DATA_REF ? sizeof(SHARED_DATA_REF) : 0);
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset, len, sectlen);
             return STATUS_INTERNAL_ERROR;
@@ -1210,71 +1368,31 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp->item->key.obj_id, tp->item->key.obj_type, tp->item->key.offset, secttype);
             return STATUS_INTERNAL_ERROR;
         }
-        
-        ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
-        if (!ref) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
+
         if (secttype == TYPE_EXTENT_DATA_REF) {
-            LIST_ENTRY* le;
-            KEY searchkey;
-            traverse_ptr tp3;
-            root* r = NULL;
-            
-            ref->type = TYPE_EXTENT_DATA_REF;
-            RtlCopyMemory(&ref->edr, ptr + sizeof(UINT8), sizeof(EXTENT_DATA_REF));
-            inline_rc += ref->edr.count;
-            
-            le = Vcb->roots.Flink;
-            while (le != &Vcb->roots) {
-                root* r2 = CONTAINING_RECORD(le, root, list_entry);
-                
-                if (r2->id == ref->edr.root) {
-                    r = r2;
-                    break;
-                }
-                
-                le = le->Flink;
-            }
-            
-            if (!r) {
-                ERR("could not find subvol %llx\n", ref->edr.count);
-                ExFreePool(ref);
-                return STATUS_INTERNAL_ERROR;
-            }
-            
-            searchkey.obj_id = ref->edr.objid;
-            searchkey.obj_type = TYPE_EXTENT_DATA;
-            searchkey.offset = ref->edr.offset;
-            
-            Status = find_item(Vcb, r, &tp3, &searchkey, FALSE, NULL);
+            EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)(ptr + sizeof(UINT8));
+
+            inline_rc += edr->count;
+
+            Status = data_reloc_add_tree_edr(Vcb, metadata_items, dr, edr, rollback);
             if (!NT_SUCCESS(Status)) {
-                ERR("find_item returned %08x\n", Status);
-                ExFreePool(ref);
+                ERR("data_reloc_add_tree_edr returned %08x\n", Status);
                 return Status;
             }
-            
-            if (keycmp(tp3.item->key, searchkey)) {
-                ERR("could not find (%llx,%x,%llx) in root %llx\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset, r->id);
-                ExFreePool(ref);
-                return STATUS_INTERNAL_ERROR;
+        } else if (secttype == TYPE_SHARED_DATA_REF) {
+            metadata_reloc* mr;
+            data_reloc_ref* ref;
+
+            ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
+            if (!ref) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
-            Status = add_metadata_reloc_parent(Vcb, metadata_items, tp3.tree->header.address, &mr, rollback);
-            if (!NT_SUCCESS(Status)) {
-                ERR("add_metadata_reloc_parent returned %08x\n", Status);
-                ExFreePool(ref);
-                return Status;
-            }
-            
-            ref->parent = mr;
-        } else if (secttype == TYPE_SHARED_DATA_REF) {
+
             ref->type = TYPE_SHARED_DATA_REF;
             RtlCopyMemory(&ref->sdr, ptr + sizeof(UINT8), sizeof(SHARED_DATA_REF));
             inline_rc += ref->sdr.count;
-            
+
             Status = add_metadata_reloc_parent(Vcb, metadata_items, ref->sdr.offset, &mr, rollback);
             if (!NT_SUCCESS(Status)) {
                 ERR("add_metadata_reloc_parent returned %08x\n", Status);
@@ -1281,102 +1399,53 @@
                 ExFreePool(ref);
                 return Status;
             }
-            
+
             ref->parent = mr;
+
+            InsertTailList(&dr->refs, &ref->list_entry);
         } else {
             ERR("unexpected tree type %x\n", secttype);
-            ExFreePool(ref);
             return STATUS_INTERNAL_ERROR;
         }
-        
-        InsertTailList(&dr->refs, &ref->list_entry);
-        
+
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
     }
-    
+
     if (inline_rc < ei->refcount) { // look for non-inline entries
         traverse_ptr tp2 = *tp, next_tp;
-        
+
         while (find_next_item(Vcb, &tp2, &next_tp, FALSE, NULL)) {
-            metadata_reloc* mr;
-            NTSTATUS Status;
-            
             tp2 = next_tp;
-            
+
             if (tp2.item->key.obj_id == tp->item->key.obj_id) {
                 if (tp2.item->key.obj_type == TYPE_EXTENT_DATA_REF && tp2.item->size >= sizeof(EXTENT_DATA_REF)) {
-                    data_reloc_ref* ref;
-                    LIST_ENTRY* le;
-                    KEY searchkey;
-                    traverse_ptr tp3;
-                    root* r = NULL;
-
-                    ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
-                    if (!ref) {
-                        ERR("out of memory\n");
-                        return STATUS_INSUFFICIENT_RESOURCES;
-                    }
-                    
-                    ref->type = TYPE_EXTENT_DATA_REF;
-                    RtlCopyMemory(&ref->edr, tp2.item->data, sizeof(EXTENT_DATA_REF));
-                    
-                    le = Vcb->roots.Flink;
-                    while (le != &Vcb->roots) {
-                        root* r2 = CONTAINING_RECORD(le, root, list_entry);
-                        
-                        if (r2->id == ref->edr.root) {
-                            r = r2;
-                            break;
-                        }
-                        
-                        le = le->Flink;
-                    }
-                    
-                    if (!r) {
-                        ERR("could not find subvol %llx\n", ref->edr.count);
-                        ExFreePool(ref);
-                        return STATUS_INTERNAL_ERROR;
-                    }
-                    
-                    searchkey.obj_id = ref->edr.objid;
-                    searchkey.obj_type = TYPE_EXTENT_DATA;
-                    searchkey.offset = ref->edr.offset;
-                    
-                    Status = find_item(Vcb, r, &tp3, &searchkey, FALSE, NULL);
+                    Status = data_reloc_add_tree_edr(Vcb, metadata_items, dr, (EXTENT_DATA_REF*)tp2.item->data, rollback);
                     if (!NT_SUCCESS(Status)) {
-                        ERR("find_item returned %08x\n", Status);
-                        ExFreePool(ref);
+                        ERR("data_reloc_add_tree_edr returned %08x\n", Status);
                         return Status;
                     }
-                    
-                    if (!keycmp(tp3.item->key, searchkey)) {
-                        ERR("could not find (%llx,%x,%llx) in root %llx\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset, r->id);
-                        ExFreePool(ref);
-                        return STATUS_INTERNAL_ERROR;
-                    }
-                    
-                    Status = add_metadata_reloc_parent(Vcb, metadata_items, tp3.tree->header.address, &mr, rollback);
+
+                    Status = delete_tree_item(Vcb, &tp2);
                     if (!NT_SUCCESS(Status)) {
-                        ERR("add_metadata_reloc_parent returned %08x\n", Status);
-                        ExFreePool(ref);
+                        ERR("delete_tree_item returned %08x\n", Status);
                         return Status;
                     }
-                    
-                    ref->parent = mr;
-                    InsertTailList(&dr->refs, &ref->list_entry);
-                    
-                    delete_tree_item(Vcb, &tp2, rollback);
-                } else if (tp2.item->key.obj_type == TYPE_SHARED_DATA_REF && tp2.item->size >= sizeof(SHARED_DATA_REF)) {
-                    data_reloc_ref* ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
+                } else if (tp2.item->key.obj_type == TYPE_SHARED_DATA_REF && tp2.item->size >= sizeof(UINT32)) {
+                    metadata_reloc* mr;
+                    data_reloc_ref* ref;
+
+                    ref = ExAllocatePoolWithTag(PagedPool, sizeof(data_reloc_ref), ALLOC_TAG);
                     if (!ref) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     ref->type = TYPE_SHARED_DATA_REF;
-                    RtlCopyMemory(&ref->sdr, tp2.item->data, sizeof(SHARED_DATA_REF));
-                    
+                    ref->sdr.offset = tp2.item->key.offset;
+                    ref->sdr.count = *((UINT32*)tp2.item->data);
+
                     Status = add_metadata_reloc_parent(Vcb, metadata_items, ref->sdr.offset, &mr, rollback);
                     if (!NT_SUCCESS(Status)) {
                         ERR("add_metadata_reloc_parent returned %08x\n", Status);
@@ -1383,23 +1452,89 @@
                         ExFreePool(ref);
                         return Status;
                     }
-                    
+
                     ref->parent = mr;
                     InsertTailList(&dr->refs, &ref->list_entry);
-                    
-                    delete_tree_item(Vcb, &tp2, rollback);
+
+                    Status = delete_tree_item(Vcb, &tp2);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
                 }
             } else
                 break;
         }
     }
-    
+
     InsertTailList(items, &dr->list_entry);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_data_reloc_extent_item(device_extension* Vcb, data_reloc* dr, LIST_ENTRY* rollback) {
+static void sort_data_reloc_refs(data_reloc* dr) {
+    LIST_ENTRY newlist, *le;
+
+    if (IsListEmpty(&dr->refs))
+        return;
+
+    // insertion sort
+
+    InitializeListHead(&newlist);
+
+    while (!IsListEmpty(&dr->refs)) {
+        data_reloc_ref* ref = CONTAINING_RECORD(RemoveHeadList(&dr->refs), data_reloc_ref, list_entry);
+        BOOL inserted = FALSE;
+
+        if (ref->type == TYPE_EXTENT_DATA_REF)
+            ref->hash = get_extent_data_ref_hash2(ref->edr.root, ref->edr.objid, ref->edr.offset);
+        else if (ref->type == TYPE_SHARED_DATA_REF)
+            ref->hash = ref->parent->new_address;
+
+        le = newlist.Flink;
+        while (le != &newlist) {
+            data_reloc_ref* ref2 = CONTAINING_RECORD(le, data_reloc_ref, list_entry);
+
+            if (ref->type < ref2->type || (ref->type == ref2->type && ref->hash > ref2->hash)) {
+                InsertHeadList(le->Blink, &ref->list_entry);
+                inserted = TRUE;
+                break;
+            }
+
+            le = le->Flink;
+        }
+
+        if (!inserted)
+            InsertTailList(&newlist, &ref->list_entry);
+    }
+
+    le = newlist.Flink;
+    while (le != &newlist) {
+        data_reloc_ref* ref = CONTAINING_RECORD(le, data_reloc_ref, list_entry);
+
+        if (le->Flink != &newlist) {
+            data_reloc_ref* ref2 = CONTAINING_RECORD(le->Flink, data_reloc_ref, list_entry);
+
+            if (ref->type == TYPE_EXTENT_DATA_REF && ref2->type == TYPE_EXTENT_DATA_REF && ref->edr.root == ref2->edr.root &&
+                ref->edr.objid == ref2->edr.objid && ref->edr.offset == ref2->edr.offset) {
+                RemoveEntryList(&ref2->list_entry);
+                ref->edr.count += ref2->edr.count;
+                ExFreePool(ref2);
+                continue;
+            }
+        }
+
+        le = le->Flink;
+    }
+
+    newlist.Flink->Blink = &dr->refs;
+    newlist.Blink->Flink = &dr->refs;
+    dr->refs.Flink = newlist.Flink;
+    dr->refs.Blink = newlist.Blink;
+}
+
+static NTSTATUS add_data_reloc_extent_item(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, data_reloc* dr) {
+    NTSTATUS Status;
     LIST_ENTRY* le;
     UINT64 rc = 0;
     UINT16 inline_len;
@@ -1407,118 +1542,120 @@
     data_reloc_ref* first_noninline = NULL;
     EXTENT_ITEM* ei;
     UINT8* ptr;
-    
+
     inline_len = sizeof(EXTENT_ITEM);
-    
+
+    sort_data_reloc_refs(dr);
+
     le = dr->refs.Flink;
     while (le != &dr->refs) {
         data_reloc_ref* ref = CONTAINING_RECORD(le, data_reloc_ref, list_entry);
-        ULONG extlen = 0;
-        
-        rc++;
-        
-        if (ref->type == TYPE_EXTENT_DATA_REF)
+        UINT16 extlen = 0;
+
+        if (ref->type == TYPE_EXTENT_DATA_REF) {
             extlen += sizeof(EXTENT_DATA_REF);
-        else if (ref->type == TYPE_SHARED_DATA_REF)
+            rc += ref->edr.count;
+        } else if (ref->type == TYPE_SHARED_DATA_REF) {
             extlen += sizeof(SHARED_DATA_REF);
+            rc++;
+        }
 
         if (all_inline) {
-            if (inline_len + 1 + extlen > Vcb->superblock.node_size / 4) {
+            if ((ULONG)(inline_len + 1 + extlen) > (Vcb->superblock.node_size >> 2)) {
                 all_inline = FALSE;
                 first_noninline = ref;
             } else
                 inline_len += extlen + 1;
         }
-        
+
         le = le->Flink;
     }
-    
+
     ei = ExAllocatePoolWithTag(PagedPool, inline_len, ALLOC_TAG);
     if (!ei) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     ei->refcount = rc;
     ei->generation = dr->ei->generation;
     ei->flags = dr->ei->flags;
     ptr = (UINT8*)&ei[1];
-    
+
     le = dr->refs.Flink;
     while (le != &dr->refs) {
         data_reloc_ref* ref = CONTAINING_RECORD(le, data_reloc_ref, list_entry);
-        
+
         if (ref == first_noninline)
             break;
-        
+
         *ptr = ref->type;
         ptr++;
-        
+
         if (ref->type == TYPE_EXTENT_DATA_REF) {
             EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)ptr;
-            
+
             RtlCopyMemory(edr, &ref->edr, sizeof(EXTENT_DATA_REF));
-            
+
             ptr += sizeof(EXTENT_DATA_REF);
         } else if (ref->type == TYPE_SHARED_DATA_REF) {
             SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)ptr;
-            
+
             sdr->offset = ref->parent->new_address;
             sdr->count = ref->sdr.count;
-            
+
             ptr += sizeof(SHARED_DATA_REF);
         }
-        
+
         le = le->Flink;
     }
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_ITEM, dr->size, ei, inline_len, NULL, NULL, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_ITEM, dr->size, ei, inline_len, NULL, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
     }
-    
+
     if (!all_inline) {
         le = &first_noninline->list_entry;
-        
+
         while (le != &dr->refs) {
             data_reloc_ref* ref = CONTAINING_RECORD(le, data_reloc_ref, list_entry);
-            
+
             if (ref->type == TYPE_EXTENT_DATA_REF) {
                 EXTENT_DATA_REF* edr;
-                UINT64 off;
-                
+
                 edr = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA_REF), ALLOC_TAG);
                 if (!edr) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 RtlCopyMemory(edr, &ref->edr, sizeof(EXTENT_DATA_REF));
-                
-                off = get_extent_data_ref_hash2(ref->edr.root, ref->edr.objid, ref->edr.offset);
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_DATA_REF, off, edr, sizeof(EXTENT_DATA_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+
+                Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_EXTENT_DATA_REF, ref->hash, edr, sizeof(EXTENT_DATA_REF), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             } else if (ref->type == TYPE_SHARED_DATA_REF) {
-                SHARED_DATA_REF* sdr;
-                
-                sdr = ExAllocatePoolWithTag(PagedPool, sizeof(SHARED_DATA_REF), ALLOC_TAG);
+                UINT32* sdr;
+
+                sdr = ExAllocatePoolWithTag(PagedPool, sizeof(UINT32), ALLOC_TAG);
                 if (!sdr) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
-                sdr->offset = ref->parent->new_address;
-                sdr->count = ref->sdr.count;
-                
-                if (!insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_SHARED_DATA_REF, sdr->offset, sdr, sizeof(SHARED_DATA_REF), NULL, NULL, rollback)) {
-                    ERR("insert_tree_item failed\n");
-                    return STATUS_INTERNAL_ERROR;
+
+                *sdr = ref->sdr.count;
+
+                Status = insert_tree_item(Vcb, Vcb->extent_root, dr->new_address, TYPE_SHARED_DATA_REF, ref->parent->new_address, sdr, sizeof(UINT32), NULL, NULL);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("insert_tree_item returned %08x\n", Status);
+                    return Status;
                 }
             }
-            
+
             le = le->Flink;
         }
     }
@@ -1535,63 +1672,63 @@
     UINT64 loaded = 0, num_loaded = 0;
     chunk* newchunk = NULL;
     UINT8* data = NULL;
-    
+
     TRACE("chunk %llx\n", c->offset);
-    
+
     InitializeListHead(&rollback);
     InitializeListHead(&items);
     InitializeListHead(&metadata_items);
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     searchkey.obj_id = c->offset;
     searchkey.obj_type = TYPE_EXTENT_ITEM;
     searchkey.offset = 0xffffffffffffffff;
-    
+
     Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         goto end;
     }
-    
+
     do {
         traverse_ptr next_tp;
-        
+
         if (tp.item->key.obj_id >= c->offset + c->chunk_item->size)
             break;
-        
+
         if (tp.item->key.obj_id >= c->offset && tp.item->key.obj_type == TYPE_EXTENT_ITEM) {
             BOOL tree = FALSE;
-            
+
             if (tp.item->key.obj_type == TYPE_EXTENT_ITEM && tp.item->size >= sizeof(EXTENT_ITEM)) {
                 EXTENT_ITEM* ei = (EXTENT_ITEM*)tp.item->data;
-                
+
                 if (ei->flags & EXTENT_ITEM_TREE_BLOCK)
                     tree = TRUE;
             }
-            
+
             if (!tree) {
                 Status = add_data_reloc(Vcb, &items, &metadata_items, &tp, c, &rollback);
-                
+
                 if (!NT_SUCCESS(Status)) {
                     ERR("add_data_reloc returned %08x\n", Status);
                     goto end;
                 }
-                
+
                 loaded += tp.item->key.offset;
                 num_loaded++;
-                
+
                 if (loaded >= 0x1000000 || num_loaded >= 100) // only do so much at a time, so we don't block too obnoxiously
                     break;
             }
         }
-    
+
         b = find_next_item(Vcb, &tp, &next_tp, FALSE, NULL);
-        
+
         if (b)
             tp = next_tp;
     } while (b);
-    
+
     if (IsListEmpty(&items)) {
         *changed = FALSE;
         Status = STATUS_SUCCESS;
@@ -1598,8 +1735,8 @@
         goto end;
     } else
         *changed = TRUE;
-    
-    data = ExAllocatePoolWithTag(PagedPool, 0x100000, ALLOC_TAG);
+
+    data = ExAllocatePoolWithTag(PagedPool, BALANCE_UNIT, ALLOC_TAG);
     if (!data) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -1612,20 +1749,22 @@
         BOOL done = FALSE;
         LIST_ENTRY* le2;
         UINT32* csum;
-        UINT64 off;
-        
+        RTL_BITMAP bmp;
+        ULONG* bmparr;
+        ULONG runlength, index, lastoff;
+
         if (newchunk) {
             ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
-            
+
             if (find_data_address_in_chunk(Vcb, newchunk, dr->size, &dr->new_address)) {
-                increase_chunk_usage(newchunk, dr->size);
-                space_list_subtract(Vcb, newchunk, FALSE, dr->new_address, dr->size, &rollback);
+                newchunk->used += dr->size;
+                space_list_subtract(newchunk, FALSE, dr->new_address, dr->size, &rollback);
                 done = TRUE;
             }
-            
+
             ExReleaseResourceLite(&newchunk->lock);
         }
-        
+
         if (!done) {
             ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
 
@@ -1632,14 +1771,14 @@
             le2 = Vcb->chunks.Flink;
             while (le2 != &Vcb->chunks) {
                 chunk* c2 = CONTAINING_RECORD(le2, chunk, list_entry);
-                
+
                 if (!c2->readonly && !c2->reloc && c2 != newchunk && c2->chunk_item->type == Vcb->data_flags) {
                     ExAcquireResourceExclusiveLite(&c2->lock, TRUE);
-                    
+
                     if ((c2->chunk_item->size - c2->used) >= dr->size) {
                         if (find_data_address_in_chunk(Vcb, c2, dr->size, &dr->new_address)) {
-                            increase_chunk_usage(c2, dr->size);
-                            space_list_subtract(Vcb, c2, FALSE, dr->new_address, dr->size, &rollback);
+                            c2->used += dr->size;
+                            space_list_subtract(c2, FALSE, dr->new_address, dr->size, &rollback);
                             ExReleaseResourceLite(&c2->lock);
                             newchunk = c2;
                             done = TRUE;
